// ====================================================================
// Copyright (C) 2018 - Samuel GOUGEON
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Overload for disp(dd)
//  - if dd is scalar, all digits are printed inline
//  - otherwise: The DD array is displayed as a list
//
// Authors :
// Copyright (C) 2018 - Samuel GOUGEON
// last updating : 2018-07-31
// *****************************************************************
function %dd_p(a)
    if size(a.hi,"*") == 1
        write(%io(2), dd2str(a))
    else
        tmp = a.hi
        tmp2 = max(abs(tmp));
        s = size(tmp);
        if tmp2==0
            out = "[d1] zeros(%d,%d)\n[d2] zeros(%d,%d)\n"
            mprintf(out, s([1 2 1 2]))
        else
            p = floor(log10(tmp2));
            if or(p==(-1:1))
                p = 0
            end
            for i = 1:2
                tmp = a(1+i);
                if and(tmp==0)
                    mprintf("[d%d] zeros(%d,%d)\n",i,s([1 2]))
                else
                    mprintf("[d%d]", i)
                    q = p - 17*(i-1)
                    if q~=0 then
                        mprintf(" 10^%d *", q)
                    end
                    disp(tmp*10^(-q))
                    mprintf("\n")
                end
            end
        end
    end
endfunction

