// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// DD division (dd / dd)
//
// Calling Sequence :
// a / b
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function c = %dd_r_dd(a,b)
    [m1,n1] = size(a.hi);
    [m2,n2] = size(b.hi);
    if (m2 == 1 & n2 == 1) then
        c = a.hi/b.hi;
        p1 = c*b.hi;

        t = 134217729 * c;
        ah = t - (t - c);
        al = c - ah;
        t = 134217729 * b.hi;
        bh = t - (t - b.hi);
        bl = b.hi - bh;
        p2 = ((ah * bh - p1) + ah * bl + al * bh) + al * bl;

        cc = (a.hi - p1 - p2 + a.lo - c*b.lo) / b.hi;

        tmp =  c + cc;
        c = tlist(['dd','hi','lo'],tmp,cc-(tmp-c));
    else
        msg = _("%s: Argument #%d: Scalar (1 element) expected.\n")
        error(msprintf(msg, "%dd_r_dd", 2));
    end
endfunction

