// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Square root of DD numbers
//
// Calling Sequence :
// sqrt(a)
//
// Arguments :
// a : DD (limited DD type value size 1 by 1)
//
// ***TODO:apply for matrix
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function sq = %dd_sqrt(a)
    [m,n] = size(a.hi);
    if (m ~= 1 | n ~= 1) then
        msg = _("%s: Argument #%d: Scalar (1 element) expected.\n")
        error(msprintf(msg, "%dd_sqrt", 1));
    else  
        if(a.hi > 0) then
            c = sqrt(a.hi); // initial value
            p1 = c*c;

            t = 134217729 * c;
            ah = t - (t - c);
            al = c - ah;
            p2 = ((ah * ah - p1) + 2.0 * ah * al) + al * al;
            cc = (a.hi - p1 - p2 + a.lo) / (c * 2.0); // Newton Iterative

            tmp =  c + cc;
            sq = tlist(['dd','hi','lo'],tmp,cc-(tmp-c));
        elseif(a.hi == 0 & a.lo == 0)
            sq = tlist(['dd','hi','lo'],0,0);
        else
            msg = _("%s: Argument #%d: Wrond value.\n")
            error(msprintf(msg, "%dd_sqrt", 1));
            // sq = tlist(['dd','hi','lo'],%nan,%nan);
        end
    end
endfunction

