// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Square root of QD numbers
//
// Calling Sequence :
// sqrt(a)
//
// Arguments :
// a : QD matrix
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function sq = %qd_sqrt(a)
    [m,n] = size(a.d);
    O = zeros(m,n);
    if(find(a(2)<O) == []) then  // check whether argument have a negative number or not
        sq = tlist(['qd','d'],O,O,O,O);
        for i=1:m
            for j=1:n
                c = 1.0/sqrt(a.d(i,j));
                c = d2qd(c);
                h = 0.5*a(i,j);	
                c = c + (0.5 - h*(c*c))*c;
                c = c + (0.5 - h*(c*c))*c;
                c = c + (0.5 - h*(c*c))*c;
                c = c*a;
                sq(i,j) = c;
            end
        end
    elseif(a(2) == O & a(3) == O & a(4) ==  O & a(5) == O)
        sq = tlist(['qd','d'],O,O,O,O);
    else
        msg = _("%s: Argument #%d: Must be >= %d.\n")
        error(msprintf(msg, "%qd_sqrt", 1, 0))
        // sq = tlist(['qd','d'],%nan,%nan,%nan,%nan);  //if argument includes a negative number
    end
endfunction

